      implicit real*8 (a-h,o-z)
	common nt,nn,beta,b,a1,a2,d,xl,xk1ss,xk,ratx,nc	 
	dimension xk(2,50),xl(2),ratx(50),p(2,50),c(2,50),w(50),r(50),
     1  cc(2,2,50),xx(2,2,50)
c
c     set number of periods
	nt=20
c
c     set number of variables and unknowns
      nn=3*nt-1	 
c
c      guess period for corner solution
	nc=4
c
c     set parameters
	beta=0.95d0
	b=-0.5d0
	a1=0.5d0
	a2=1.d0-a1
	d=10.d0
	xl(1)=10.d0
	xl(2)=10.d0
      xxl=xl(1)+xl(2)
	zk10=0.6d0
	zk20=0.2d0
	xk10=zk10*xl(1)
	xk20=zk20*xl(2)
c
c	calculate initial aggregate capital-labor ratio
	zk0=(xl(1)*zk10+xl(2)*zk20)/(xl(1)+xl(2))
c
c     calculate steady state aggregate capital-labor ratio
      if(dabs(b).ge.1.d-8) then
        xk1ss=(a2*xxl**b/((a1*beta*d)**(-b/(1.d0-b))-a1))**(1.d0/b)
      endif
	zk1ss=xk1ss/xl(1)
c
c     calculate steady state x2/x1
     	x1ss=xk1ss
	x2ss=xl(1)+xl(2)
	ratxss=x2ss/x1ss
c
c     calculate inital x2/x1
     	x10=xk10+xk20
	x20=xl(1)+xl(2)
	ratx0=x20/x10
c
c     guess path
      xk(1,1)=xk10
	xk(2,1)=xk20	
	ratx(1)=ratx0
	xk2ss=0.d0
      do 50 it=2,5
	  z=(it-1.d0)/5.d0
	  xk(1,it)=(1.d0-z)*xk10+z*xk1ss
	  xk(2,it)=(1.d0-z)*xk20+z*xk2ss
	  ratx(it)=(1.d0-z)*ratx0+z*ratxss
 50   continue
      do 60 it=6,nt+1
	  xk(1,it)=xk1ss
	  xk(2,it)=xk2ss
	  ratx(it)=ratxss
 60   continue
c
c	solve for equilibrium using Newton's method
	call solve
c
	do 180 it=1,nt+1
	  p(1,it)=a1*d*(a1+a2*ratx(it)**b)**(1.d0/b-1.d0)
	  p(2,it)=a2*ratx(it)**(b-1.d0)*d*(a1+a2*ratx(it)**b)
     1    **(1.d0/b-1.d0)
        r(it)=p(1,it)
	  w(it)=p(2,it)
	  do 170 i=1,2
          xx(i,1,it)=xk(i,it+1)/f(1.d0,ratx(it))
	    xx(i,2,it)=xk(i,it+1)/f(1.d0/ratx(it),1.d0)
	    xinci=p(1,it)*xk(i,it)+p(2,it)*xl(i)
	    c(i,it)=xinci-xk(i,it+1)
	    cc(i,1,it)=c(i,it)/f(1.d0,ratx(it))
	    cc(i,2,it)=c(i,it)/f(1.d0/ratx(it),1.d0)
 170    continue
 180  continue
c
      open(unit=9,file='CornerResults.txt')
 1111 format(1x,'        k1          k2          r           w')
      write(6,1111)												  
	write(9,1111)
      do 190 it=1,nt
	  zk=(xk(1,it)+xk(2,it))/(xl(1)+xl(2))
	  write(6,1112)it-1,xk(1,it),xk(2,it),r(it),w(it)
	  write(9,1112)it-1,xk(1,it),xk(2,it),r(it),w(it)

 1112   format(1x,i3,4f12.6)
  190 continue
c
      stop
	end